// General_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlockIO5068_1.H"

#include "General_Dlg.h"
#include "BlockIOAPI.h"
#include "BlockIO5068.h"

#ifdef _DEBUG

#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg dialog


CGeneral_Dlg::CGeneral_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGeneral_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGeneral_Dlg)
	mHandle = 0;
	//}}AFX_DATA_INIT
}


void CGeneral_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneral_Dlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneral_Dlg, CDialog)
	//{{AFX_MSG_MAP(CGeneral_Dlg)
	ON_BN_CLICKED(IDC_SETMODULECONFIG, OnSetmoduleconfig)
	ON_BN_CLICKED(IDC_MODULEHANDLECREATRE, OnModulehandlecreatre)
	ON_BN_CLICKED(IDC_MODULEHANDLERELEASE, OnModulehandlerelease)
	ON_BN_CLICKED(IDC_SETWATCHDOGCONFIG, OnSetwatchdogconfig)
	ON_BN_CLICKED(IDC_WATCHDOG, OnWatchdog)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_CHECK14, OnCheck14)
	ON_BN_CLICKED(IDC_CHECK15, OnCheck15)
	ON_BN_CLICKED(IDC_CHECK16, OnCheck16)
	ON_BN_CLICKED(IDC_CHECK17, OnCheck17)
	ON_BN_CLICKED(IDC_CHECK18, OnCheck18)
	ON_BN_CLICKED(IDC_CHECK19, OnCheck19)
	ON_BN_CLICKED(IDC_CHECK20, OnCheck20)
	ON_BN_CLICKED(IDC_CHECK21, OnCheck21)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg message handlers

void CGeneral_Dlg::OnSetmoduleconfig() 
{
	// TODO: Add your control notification handler code here
	BYTE byNewAddr    = 0;

	CEdit *edt;
	CString str;
	int temp = 0;
	
	edt = (CEdit *)GetDlgItem(IDC_GEDTID);
	edt->GetWindowText(str);
    byNewAddr = (BYTE)_atoi64(str);
 
//Eddie	byRet = L6000_SetModuleConfig(mHandle, byNewAddr, byInputRange, byBaudrate, byDataFormat, byChecksum);
			
}

void CGeneral_Dlg::OnModulehandlecreatre() 
{
	// TODO: Add your control notification handler code here
	CEdit  *edt;
	CString cstr;

	edt = (CEdit *)GetDlgItem(IDC_GEDTID);
	edt->GetWindowText(cstr);

	if (cstr.IsEmpty())
	{
		MessageBox("Please input IP address!", "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		return;
	}

	//install
	((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(FALSE);
	DWORD dwRet = SYS_Install(&mHandle, cstr);
	if (!ERR_OK(dwRet))
	{
		dwRet = dwRet & 0xFF; //the last byte of the return code shows error
		cstr.Format("Function SYS_Install returns error code: %d!", dwRet);
		MessageBox(cstr, "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(TRUE);
		return;
	}

	//get the name of module
	char szModuleName[10] = "";
	size_t nSize = 10;
	SYS_GetModuleName(mHandle, szModuleName, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTMODULENAME);
	edt->SetWindowText(szModuleName);
	//end 

	//get firmware version of module
	char szFirmwareVersion[10] = "";
	SYS_GetModuleFirmware(mHandle, szFirmwareVersion, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTFIRMWARE);
	edt->SetWindowText(szFirmwareVersion);
	//end

	//getWatchDogConfig
	BOOL bEnabled;
	double dblWDTimer;
	SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
	((CButton*)GetDlgItem(IDC_WATCHDOG))->SetCheck(bEnabled);
	CString str;
	str.Format("%f", dblWDTimer);
	((CEdit *)GetDlgItem(IDC_TIMER))->SetWindowText(str);
	//end

	((CButton *)GetDlgItem(IDC_WATCHDOG))->EnableWindow(TRUE);
	((CEdit *)GetDlgItem(IDC_TIMER))->EnableWindow(bEnabled);	
	((CButton *)GetDlgItem(IDC_SETWATCHDOGCONFIG))->EnableWindow(TRUE);
	
	//BlockIO5068 
	//get IO status
	WORD dwDI;
	BYTE dwDO;
	DIO_GetDIO(mHandle, (BYTE *)&dwDI, &dwDO);

	((CButton*)GetDlgItem(IDC_CHECK0))->SetCheck(dwDI & (1 << 0));
	((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(dwDI & (1 << 1));
	((CButton*)GetDlgItem(IDC_CHECK2))->SetCheck(dwDI & (1 << 2));
	((CButton*)GetDlgItem(IDC_CHECK3))->SetCheck(dwDI & (1 << 3));
	((CButton*)GetDlgItem(IDC_CHECK4))->SetCheck(dwDI & (1 << 4));
	((CButton*)GetDlgItem(IDC_CHECK5))->SetCheck(dwDI & (1 << 5));
	((CButton*)GetDlgItem(IDC_CHECK6))->SetCheck(dwDI & (1 << 6));
	((CButton*)GetDlgItem(IDC_CHECK7))->SetCheck(dwDI & (1 << 7));
	((CButton*)GetDlgItem(IDC_CHECK8))->SetCheck(dwDI & (1 << 8));
	((CButton*)GetDlgItem(IDC_CHECK9))->SetCheck(dwDI & (1 << 9));
	((CButton*)GetDlgItem(IDC_CHECK10))->SetCheck(dwDI & (1 << 10));
	((CButton*)GetDlgItem(IDC_CHECK11))->SetCheck(dwDI & (1 << 11));
	((CButton*)GetDlgItem(IDC_CHECK12))->SetCheck(dwDI & (1 << 12));
	((CButton*)GetDlgItem(IDC_CHECK13))->SetCheck(dwDI & (1 << 13));

	((CButton*)GetDlgItem(IDC_CHECK14))->SetCheck(dwDO & (1 << 0));
	((CButton*)GetDlgItem(IDC_CHECK15))->SetCheck(dwDO & (1 << 1));
	((CButton*)GetDlgItem(IDC_CHECK16))->SetCheck(dwDO & (1 << 2));
	((CButton*)GetDlgItem(IDC_CHECK17))->SetCheck(dwDO & (1 << 3));
	((CButton*)GetDlgItem(IDC_CHECK18))->SetCheck(dwDO & (1 << 4));
	((CButton*)GetDlgItem(IDC_CHECK19))->SetCheck(dwDO & (1 << 5));
	((CButton*)GetDlgItem(IDC_CHECK20))->SetCheck(dwDO & (1 << 6));
	((CButton*)GetDlgItem(IDC_CHECK21))->SetCheck(dwDO & (1 << 7));

	((CButton*)GetDlgItem(IDC_CHECK14))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK15))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK16))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK17))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK18))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK19))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK20))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_CHECK21))->EnableWindow(TRUE);

	((CButton*)GetDlgItem(IDC_BUTTON1))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_BUTTON2))->EnableWindow(TRUE);

	SetTimer(1, 100, NULL);
	
	((CButton *)GetDlgItem(IDC_MODULEHANDLERELEASE))->EnableWindow(TRUE);
}

BOOL CGeneral_Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_GEDTID, "192.168.10.50");
	return TRUE;  
}

void CGeneral_Dlg::OnModulehandlerelease() 
{
	// TODO: Add your control notification handler code here
	KillTimer(1);

	DWORD dwRet;
	dwRet =SYS_Release(mHandle);
	mHandle = NULL;

	((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(TRUE);
	((CButton *)GetDlgItem(IDC_MODULEHANDLERELEASE))->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_WATCHDOG))->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_SETWATCHDOGCONFIG))->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_WATCHDOG))->SetCheck(0);
	((CEdit *)GetDlgItem(IDC_TIMER))->EnableWindow(FALSE);	

	CEdit *edt;
	edt = (CEdit *)GetDlgItem(IDC_TIMER);
	edt->SetWindowText("");
	edt = (CEdit *)GetDlgItem(IDC_GEDTMODULENAME);
	edt->SetWindowText("");
	edt = (CEdit *)GetDlgItem(IDC_GEDTFIRMWARE);
	edt->SetWindowText("");
	
	//BlockIO5068 IO
	//
	((CButton *)GetDlgItem(IDC_CHECK0))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK2))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK4))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK5))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK6))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK7))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK8))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK9))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK10))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK11))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK12))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK13))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK14))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK15))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK16))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK17))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK18))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK19))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK20))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK21))->SetCheck(0);
	//
	((CButton*)GetDlgItem(IDC_CHECK14))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK15))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK16))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK17))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK18))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK19))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK20))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_CHECK21))->EnableWindow(FALSE);
	
	((CButton*)GetDlgItem(IDC_BUTTON1))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_BUTTON2))->EnableWindow(FALSE);
}

void CGeneral_Dlg::OnSetwatchdogconfig() 
{
	// TODO: Add your control notification handler code here
	BOOL bEnabled = ((CButton*)GetDlgItem(IDC_WATCHDOG))->GetCheck();
	CString cstr;
	CEdit *edt;
	edt = (CEdit *)GetDlgItem(IDC_TIMER);
	edt->GetWindowText(cstr);
	double dblWDTimer = atof(cstr);
	SYS_SetWatchDogConfig(mHandle, bEnabled, dblWDTimer);	
}

void CGeneral_Dlg::OnWatchdog() 
{
	BOOL bSelect;
	bSelect = ((CButton*)GetDlgItem(IDC_WATCHDOG))->GetCheck();
	((CEdit *)GetDlgItem(IDC_TIMER))->EnableWindow(bSelect);
}

void CGeneral_Dlg::OnButton1() 
{
	DIO_SetSafetyDO(mHandle);
}

void CGeneral_Dlg::OnButton2() 
{
	DIO_SetPowerOnDO(mHandle);	
}

void CGeneral_Dlg::OnCheck14() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK14))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 0, bselect);	
}

void CGeneral_Dlg::OnCheck15() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK15))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 1, bselect);	
}

void CGeneral_Dlg::OnCheck16() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK16))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 2, bselect);	
}

void CGeneral_Dlg::OnCheck17() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK17))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 3, bselect);	
}

void CGeneral_Dlg::OnCheck18() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK18))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 4, bselect);	
}

void CGeneral_Dlg::OnCheck19() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK19))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 5, bselect);	
}

void CGeneral_Dlg::OnCheck20() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK20))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 6, bselect);	
}

void CGeneral_Dlg::OnCheck21() 
{
	// TODO: Add your control notification handler code here
	bool bselect = ((CButton*)GetDlgItem(IDC_CHECK21))->GetCheck() ? TRUE : FALSE;
	DIO_SetDO(mHandle, 7, bselect);	
}

void CGeneral_Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	WORD dwDI;
	BYTE dwDO;
	DIO_GetDIO(mHandle, (BYTE *)&dwDI, &dwDO);

	((CButton*)GetDlgItem(IDC_CHECK0))->SetCheck(dwDI & (1 << 0));
	((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(dwDI & (1 << 1));
	((CButton*)GetDlgItem(IDC_CHECK2))->SetCheck(dwDI & (1 << 2));
	((CButton*)GetDlgItem(IDC_CHECK3))->SetCheck(dwDI & (1 << 3));
	((CButton*)GetDlgItem(IDC_CHECK4))->SetCheck(dwDI & (1 << 4));
	((CButton*)GetDlgItem(IDC_CHECK5))->SetCheck(dwDI & (1 << 5));
	((CButton*)GetDlgItem(IDC_CHECK6))->SetCheck(dwDI & (1 << 6));
	((CButton*)GetDlgItem(IDC_CHECK7))->SetCheck(dwDI & (1 << 7));
	((CButton*)GetDlgItem(IDC_CHECK8))->SetCheck(dwDI & (1 << 8));
	((CButton*)GetDlgItem(IDC_CHECK9))->SetCheck(dwDI & (1 << 9));
	((CButton*)GetDlgItem(IDC_CHECK10))->SetCheck(dwDI & (1 << 10));
	((CButton*)GetDlgItem(IDC_CHECK11))->SetCheck(dwDI & (1 << 11));
	((CButton*)GetDlgItem(IDC_CHECK12))->SetCheck(dwDI & (1 << 12));
	((CButton*)GetDlgItem(IDC_CHECK13))->SetCheck(dwDI & (1 << 13));

	((CButton*)GetDlgItem(IDC_CHECK14))->SetCheck(dwDO & (1 << 0));
	((CButton*)GetDlgItem(IDC_CHECK15))->SetCheck(dwDO & (1 << 1));
	((CButton*)GetDlgItem(IDC_CHECK16))->SetCheck(dwDO & (1 << 2));
	((CButton*)GetDlgItem(IDC_CHECK17))->SetCheck(dwDO & (1 << 3));
	((CButton*)GetDlgItem(IDC_CHECK18))->SetCheck(dwDO & (1 << 4));
	((CButton*)GetDlgItem(IDC_CHECK19))->SetCheck(dwDO & (1 << 5));
	((CButton*)GetDlgItem(IDC_CHECK20))->SetCheck(dwDO & (1 << 6));
	((CButton*)GetDlgItem(IDC_CHECK21))->SetCheck(dwDO & (1 << 7));
	
	CDialog::OnTimer(nIDEvent);
}

void CGeneral_Dlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(mHandle) SYS_Release(mHandle);
	CDialog::OnClose();
}
