// General_Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "BlockIO5024_1.H"

#include "General_Dlg.h"
#include "BlockIOAPI.h"
#include "BlockIO5024.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE mHandle = 0;

/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg dialog


CGeneral_Dlg::CGeneral_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGeneral_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGeneral_Dlg)
	//}}AFX_DATA_INIT
}


void CGeneral_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneral_Dlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneral_Dlg, CDialog)
	//{{AFX_MSG_MAP(CGeneral_Dlg)
	ON_BN_CLICKED(IDC_SETMODULECONFIG, OnSetmoduleconfig)
	ON_BN_CLICKED(IDC_MODULEHANDLECREATRE, OnModulehandlecreatre)
	ON_BN_CLICKED(IDC_MODULEHANDLERELEASE, OnModulehandlerelease)
	ON_BN_CLICKED(IDC_SETWATCHDOGCONFIG, OnSetwatchdogconfig)
	ON_BN_CLICKED(IDC_SETAO0, OnSetao0)
	ON_BN_CLICKED(IDC_SETAO1, OnSetao1)
	ON_BN_CLICKED(IDC_SETPOWER0, OnSetpower0)
	ON_BN_CLICKED(IDC_SETPOWER1, OnSetpower1)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SETPOWER2, OnSetpower2)
	ON_BN_CLICKED(IDC_SETPOWER3, OnSetpower3)
	ON_BN_CLICKED(IDC_SETAO2, OnSetao2)
	ON_BN_CLICKED(IDC_SETAO3, OnSetao3)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_GCBOOUTPUTRANGE, OnSelchangeGcbooutputrange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg message handlers

void CGeneral_Dlg::OnSetmoduleconfig() 
{
	// TODO: Add your control notification handler code here
	I5024_PARAM param;
	memset(&param, 0, sizeof(param));
	param.bySlewRates[0] = ((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->GetCurSel();
	param.bySlewRates[1] = ((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->GetCurSel();
	param.bySlewRates[2] = ((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->GetCurSel();
	param.bySlewRates[3] = ((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->GetCurSel();
	param.byOutputRanges[0] = ((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->GetCurSel();
	param.byOutputRanges[1] = ((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->GetCurSel();
	param.byOutputRanges[2] = ((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->GetCurSel();
	param.byOutputRanges[3] = ((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->GetCurSel();
	param.byMask = 3;
	DWORD dwRet = AO_SetConfig(mHandle, &param);
}

void CGeneral_Dlg::OnModulehandlecreatre() 
{
	// TODO: Add your control notification handler code here
	CEdit *edt;
	CString cstr;
	edt = (CEdit *)GetDlgItem(IDC_GEDTID);
	edt->GetWindowText(cstr);
	if(cstr.IsEmpty())
	{
		MessageBox("Please input IP address", "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		return;
	}

	//install
	((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(FALSE);
	DWORD dwRet = SYS_Install(&mHandle, cstr);
	if (!ERR_OK(dwRet))
	{
		dwRet = dwRet & 0xFF; //the last byte of the return code shows error
		cstr.Format("Function SYS_Install returns error code: %d!", dwRet);
		MessageBox(cstr, "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(TRUE);
		return;
	}
	GetDlgItem(IDC_MODULEHANDLERELEASE)->EnableWindow(TRUE);
	//end

	//get the name of module
	char szModuleName[10] = "";
	size_t nSize = 10;
	SYS_GetModuleName(mHandle, szModuleName, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTMODULENAME);
	edt->SetWindowText(szModuleName);
	//end 

	//get firmware version of module
	char szFirmwareVersion[10] = "";
	SYS_GetModuleFirmware(mHandle, szFirmwareVersion, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTFIRMWARE);
	edt->SetWindowText(szFirmwareVersion);
	//end

	//get slew rate and output range
	I5024_PARAM param;
	memset(&param, 0, sizeof(param));
	AO_GetConfig(mHandle, &param);
//	((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->SetCurSel(param.bySlewRates[0]);
	((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->SetCurSel(param.byOutputRanges[0]);
	//
	CComboBox *cbxSlewRate = (CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE); 
	while(cbxSlewRate->GetCount()>0) cbxSlewRate->DeleteString(0);
	if (0 == param.byOutputRanges[0])
	{
		cbxSlewRate->AddString("immediate change");
		cbxSlewRate->AddString("0.0625");
		cbxSlewRate->AddString("0.125");
		cbxSlewRate->AddString("0.25");
		cbxSlewRate->AddString("0.5");
		cbxSlewRate->AddString("1.0");
		cbxSlewRate->AddString("2.0");
		cbxSlewRate->AddString("4.0");
		cbxSlewRate->AddString("8.0");
		cbxSlewRate->AddString("16.0");
		cbxSlewRate->AddString("32.0");
		cbxSlewRate->AddString("64.0");
	}
	else
	{
		cbxSlewRate->AddString("immediate change");
		cbxSlewRate->AddString("0.125");
		cbxSlewRate->AddString("0.25");
		cbxSlewRate->AddString("0.5");
		cbxSlewRate->AddString("1.0");
		cbxSlewRate->AddString("2.0");
		cbxSlewRate->AddString("4.0");
		cbxSlewRate->AddString("8.0");
		cbxSlewRate->AddString("16.0");
		cbxSlewRate->AddString("32.0");
		cbxSlewRate->AddString("64.0");
		cbxSlewRate->AddString("128.0");
	}
	((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->SetCurSel(param.bySlewRates[0]);
	//
	GetDlgItem(IDC_GCBOSLEWRATE)->EnableWindow(TRUE);
	GetDlgItem(IDC_GCBOOUTPUTRANGE)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(TRUE);
	//end

	//getWatchDogConfig
	BOOL bEnabled;
	double dblWDTimer;
	SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
	((CButton*)GetDlgItem(IDC_WATCHDOG))->SetCheck(bEnabled);
	CString str;
	str.Format("%f", dblWDTimer);
	((CEdit *)GetDlgItem(IDC_TIMER))->SetWindowText(str);
	GetDlgItem(IDC_WATCHDOG)->EnableWindow(TRUE);
	GetDlgItem(IDC_TIMER)->EnableWindow(TRUE);	
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(TRUE);
	//end

	/*
	double pdbValue = 0.0;
	WORD wVal;
	//channel
	AO_GetAO(mHandle, 0, &pdbValue);
	cstr.Format("%.3f", pdbValue);
	SetDlgItemText(IDC_EDIT_SETAO0, cstr);
	AO_GetPowerOnValue(mHandle, 0, &wVal);
	cstr.Format("%d", wVal);
	SetDlgItemText(IDC_EDIT_AO0, cstr);
	GetDlgItem(IDC_EDIT_SETAO0)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO0)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER0)->EnableWindow(TRUE);

	AO_GetAO(mHandle, 1, &pdbValue);
	cstr.Format("%.3f", pdbValue);
	SetDlgItemText(IDC_EDIT_SETAO1, cstr);
	AO_GetPowerOnValue(mHandle, 1, &wVal);
	cstr.Format("%d", wVal);
	SetDlgItemText(IDC_EDIT_AO1, cstr);
	GetDlgItem(IDC_EDIT_SETAO1)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO1)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER1)->EnableWindow(TRUE);

	AO_GetAO(mHandle, 2, &pdbValue);
	cstr.Format("%.3f", pdbValue);
	SetDlgItemText(IDC_EDIT_SETAO2, cstr);
	AO_GetPowerOnValue(mHandle, 2, &wVal);
	cstr.Format("%d", wVal);
	SetDlgItemText(IDC_EDIT_AO2, cstr);
	GetDlgItem(IDC_EDIT_SETAO2)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO2)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER2)->EnableWindow(TRUE);

	AO_GetAO(mHandle, 3, &pdbValue);
	cstr.Format("%.3f", pdbValue);
	SetDlgItemText(IDC_EDIT_SETAO3, cstr);
	AO_GetPowerOnValue(mHandle, 3, &wVal);
	cstr.Format("%d", wVal);
	SetDlgItemText(IDC_EDIT_AO3, cstr);
	GetDlgItem(IDC_EDIT_SETAO3)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO3)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER3)->EnableWindow(TRUE);
	*/

	//enable channel
	GetDlgItem(IDC_EDIT_SETAO0)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO0)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER0)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_SETAO1)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO1)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER1)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_SETAO2)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO2)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER2)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_SETAO3)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETAO3)->EnableWindow(TRUE);
	GetDlgItem(IDC_SETPOWER3)->EnableWindow(TRUE);

	//start the timer of getting the AOs' value
	SetTimer(1, 1000, NULL);
	//end
}

BOOL CGeneral_Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_GEDTID, "192.168.10.20");

	return TRUE;  
}

void CGeneral_Dlg::OnModulehandlerelease() 
{
	// TODO: Add your control notification handler code here
	KillTimer(1);

	DWORD dwRet;
	dwRet =SYS_Release(mHandle);
	mHandle = NULL;

	GetDlgItem(IDC_EDIT_SETAO0)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETAO0)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETPOWER0)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT_AO0, "");
	SetDlgItemText(IDC_EDIT_SETAO0, "");

	GetDlgItem(IDC_EDIT_SETAO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETAO1)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETPOWER1)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT_AO1, "");
	SetDlgItemText(IDC_EDIT_SETAO1, "");

	GetDlgItem(IDC_EDIT_SETAO2)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETAO2)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETPOWER2)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT_AO2, "");
	SetDlgItemText(IDC_EDIT_SETAO2, "");

	GetDlgItem(IDC_EDIT_SETAO3)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETAO3)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETPOWER3)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT_AO3, "");
	SetDlgItemText(IDC_EDIT_SETAO3, "");

	GetDlgItem(IDC_WATCHDOG)->EnableWindow(FALSE);
	GetDlgItem(IDC_TIMER)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(FALSE);
	SetDlgItemText(IDC_TIMER, "");
	((CButton *)GetDlgItem(IDC_WATCHDOG))->SetCheck(0);

	GetDlgItem(IDC_GCBOSLEWRATE)->EnableWindow(FALSE);
	GetDlgItem(IDC_GCBOOUTPUTRANGE)->EnableWindow(FALSE);
	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(FALSE);
	((CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE))->SetCurSel(-1);
	((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->SetCurSel(-1);

	SetDlgItemText(IDC_GEDTFIRMWARE, "");
	SetDlgItemText(IDC_GEDTMODULENAME, "");

	GetDlgItem(IDC_MODULEHANDLERELEASE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MODULEHANDLECREATRE)->EnableWindow(TRUE);
}

void CGeneral_Dlg::OnSetwatchdogconfig() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(FALSE);
	BOOL bEnabled = ((CButton*)GetDlgItem(IDC_WATCHDOG))->GetCheck();
	CString cstr;
	GetDlgItemText(IDC_TIMER, cstr);
	double dblWDTimer = atof(cstr);
	SYS_SetWatchDogConfig(mHandle, bEnabled, dblWDTimer);
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(TRUE);
}

void CGeneral_Dlg::OnSetao0() 
{
	// TODO: Add your control notification handler code here
	double dbAO;
	CString str;
	GetDlgItemText(IDC_EDIT_SETAO0, str);
	dbAO = atof(str);
	DWORD dwRet = AO_SetAO(mHandle, 0, dbAO);
}

void CGeneral_Dlg::OnSetao1() 
{
	// TODO: Add your control notification handler code here
	double dbAO;
	CString str;
	GetDlgItemText(IDC_EDIT_SETAO1, str);
	dbAO = atof(str);
	DWORD dwRet = AO_SetAO(mHandle, 1, dbAO);
}

void CGeneral_Dlg::OnSetpower0() 
{
	// TODO: Add your control notification handler code here
	DWORD ret = AO_SetPowerOnValue(mHandle, 0);
}

void CGeneral_Dlg::OnSetpower1() 
{
	// TODO: Add your control notification handler code here
	DWORD ret = AO_SetPowerOnValue(mHandle, 1);
}

void CGeneral_Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	double dbValue[I5024_CH_NUM];
	CString str;
    DWORD dwRet = AO_GetAO(mHandle, 255, dbValue);

	str.Format("%.3f", dbValue[0]);
	SetDlgItemText(IDC_EDIT_AO0, str);
	str.Format("%.3f", dbValue[1]);
	SetDlgItemText(IDC_EDIT_AO1, str);
	str.Format("%.3f", dbValue[2]);
	SetDlgItemText(IDC_EDIT_AO2, str);
	str.Format("%.3f", dbValue[3]);
	SetDlgItemText(IDC_EDIT_AO3, str);

	CDialog::OnTimer(nIDEvent);
}

void CGeneral_Dlg::OnSetpower2() 
{
	// TODO: Add your control notification handler code here
	DWORD ret = AO_SetPowerOnValue(mHandle, 2);
}

void CGeneral_Dlg::OnSetpower3() 
{
	// TODO: Add your control notification handler code here
	DWORD ret = AO_SetPowerOnValue(mHandle, 3);
}

void CGeneral_Dlg::OnSetao2() 
{
	// TODO: Add your control notification handler code here
	double dbAO;
	CString str;
	GetDlgItemText(IDC_EDIT_SETAO2, str);
	dbAO = atof(str);
	DWORD dwRet = AO_SetAO(mHandle, 2, dbAO);
}

void CGeneral_Dlg::OnSetao3() 
{
	// TODO: Add your control notification handler code here
	double dbAO;
	CString str;
	GetDlgItemText(IDC_EDIT_SETAO3, str);
	dbAO = atof(str);
	DWORD dwRet = AO_SetAO(mHandle, 3, dbAO);
}

void CGeneral_Dlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if(mHandle) SYS_Release(mHandle);
	CDialog::OnClose();
}

void CGeneral_Dlg::OnSelchangeGcbooutputrange() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbxSlewRate = (CComboBox *)GetDlgItem(IDC_GCBOSLEWRATE);
	int nSel = cbxSlewRate->GetCurSel();
	while(cbxSlewRate->GetCount()>0) cbxSlewRate->DeleteString(0);
	if (0 == ((CComboBox *)GetDlgItem(IDC_GCBOOUTPUTRANGE))->GetCurSel())
	{
		cbxSlewRate->AddString("immediate change");
		cbxSlewRate->AddString("0.0625");
		cbxSlewRate->AddString("0.125");
		cbxSlewRate->AddString("0.25");
		cbxSlewRate->AddString("0.5");
		cbxSlewRate->AddString("1.0");
		cbxSlewRate->AddString("2.0");
		cbxSlewRate->AddString("4.0");
		cbxSlewRate->AddString("8.0");
		cbxSlewRate->AddString("16.0");
		cbxSlewRate->AddString("32.0");
		cbxSlewRate->AddString("64.0");
	}
	else
	{
		cbxSlewRate->AddString("immediate change");
		cbxSlewRate->AddString("0.125");
		cbxSlewRate->AddString("0.25");
		cbxSlewRate->AddString("0.5");
		cbxSlewRate->AddString("1.0");
		cbxSlewRate->AddString("2.0");
		cbxSlewRate->AddString("4.0");
		cbxSlewRate->AddString("8.0");
		cbxSlewRate->AddString("16.0");
		cbxSlewRate->AddString("32.0");
		cbxSlewRate->AddString("64.0");
		cbxSlewRate->AddString("128.0");
	}
	cbxSlewRate->SetCurSel(nSel);
}
