// General_Dlg1.cpp : implementation file
//

#include "stdafx.h"
#include "BlockIO5017_1.h"

#include "General_Dlg1.h"
#include "BlockIOAPI.h"
#include "BlockIO5017.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


HANDLE mHandle = 0;

/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg dialog


CGeneral_Dlg::CGeneral_Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGeneral_Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGeneral_Dlg)
	//}}AFX_DATA_INIT
}


void CGeneral_Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGeneral_Dlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGeneral_Dlg, CDialog)
	//{{AFX_MSG_MAP(CGeneral_Dlg)
	ON_BN_CLICKED(IDC_SETMODULECONFIG, OnSetmoduleconfig)
	ON_BN_CLICKED(IDC_MODULEHANDLECREATRE, OnModulehandlecreatre)
	ON_BN_CLICKED(IDC_MODULEHANDLERELEASE, OnModulehandlerelease)
	ON_BN_CLICKED(IDC_SETWATCHDOGCONFIG, OnSetwatchdogconfig)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK0, OnCheck0)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGeneral_Dlg message handlers

void CGeneral_Dlg::OnSetmoduleconfig() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(FALSE);

	int nSel = ((CComboBox *)GetDlgItem(IDC_GCBOINPUTRANGE))->GetCurSel();
	nSel += 8;
	AI_SetInputRange(mHandle, nSel);

	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(TRUE);
}

void CGeneral_Dlg::OnModulehandlecreatre() 
{
	// TODO: Add your control notification handler code here
	CEdit *edt;
	CString cstr;
	edt = (CEdit *)GetDlgItem(IDC_GEDTID);
	edt->GetWindowText(cstr);
	if(cstr == "")
	{
		MessageBox("Please input IP address!", "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		return;
	}

	//install
	((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(FALSE);
	DWORD dwRet = SYS_Install(&mHandle, cstr);
	if (!ERR_OK(dwRet))
	{
		dwRet = dwRet & 0xFF; //the last byte of the return code shows error
		cstr.Format("Function SYS_Install returns error code: %d!", dwRet);
		MessageBox(cstr, "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
		((CButton *)GetDlgItem(IDC_MODULEHANDLECREATRE))->EnableWindow(TRUE);
		return;
	}
	GetDlgItem(IDC_MODULEHANDLERELEASE)->EnableWindow(TRUE);
	//end

	//get the name of module
	char szModuleName[10] = "";
	size_t nSize = 10;
	SYS_GetModuleName(mHandle, szModuleName, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTMODULENAME);
	edt->SetWindowText(szModuleName);
	//end 

	//get firmware version of module
	char szFirmwareVersion[10] = "";
	SYS_GetModuleFirmware(mHandle, szFirmwareVersion, nSize);
	edt = (CEdit *)GetDlgItem(IDC_GEDTFIRMWARE);
	edt->SetWindowText(szFirmwareVersion);
	//end

/*
Input range (address low)  
Code:08H~0DH  
08H:  10V
09H:  5V
0AH:  1V
0BH:  500mV
0CH:  150mV
0DH:  20mA
*/
	//get input range
	BYTE byIR;
	AI_GetInputRange(mHandle, &byIR);
	byIR -= 8;
	CComboBox *pBox = (CComboBox *)GetDlgItem(IDC_GCBOINPUTRANGE);
	pBox->SetCurSel(byIR);
	pBox->EnableWindow(TRUE);
	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(TRUE);
	//end

	//getWatchDogConfig
	BOOL bEnabled;
	double dblWDTimer;
	SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
	((CButton*)GetDlgItem(IDC_WATCHDOG))->SetCheck(bEnabled);
	CString str;
	str.Format("%f", dblWDTimer);
	((CEdit *)GetDlgItem(IDC_TIMER))->SetWindowText(str);
	GetDlgItem(IDC_WATCHDOG)->EnableWindow(TRUE);
	GetDlgItem(IDC_TIMER)->EnableWindow(TRUE);	
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(TRUE);
	//end

	//get channel status
	BYTE byStatus;
	dwRet = AI_GetChannelStatus(mHandle, &byStatus);
	//timer
	GetDlgItem(IDC_CHECK0)->EnableWindow(TRUE);
	if (byStatus & 1)
	{
		((CButton *)GetDlgItem(IDC_CHECK0))->SetCheck(1);
		GetDlgItem(IDC_EDIT0)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK1)->EnableWindow(TRUE);
	if (byStatus & 2)
	{
		((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(1);
		GetDlgItem(IDC_EDIT1)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK2)->EnableWindow(TRUE);
	if (byStatus & 4)
	{
		((CButton *)GetDlgItem(IDC_CHECK2))->SetCheck(1);
		GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK3)->EnableWindow(TRUE);
	if (byStatus & 8)
	{
		((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(1);
		GetDlgItem(IDC_EDIT3)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK4)->EnableWindow(TRUE);
	if (byStatus & 16)
	{
		((CButton *)GetDlgItem(IDC_CHECK4))->SetCheck(1);
		GetDlgItem(IDC_EDIT4)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK5)->EnableWindow(TRUE);
	if (byStatus & 32)
	{
		((CButton *)GetDlgItem(IDC_CHECK5))->SetCheck(1);
		GetDlgItem(IDC_EDIT5)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK6)->EnableWindow(TRUE);
	if (byStatus & 64)
	{
		((CButton *)GetDlgItem(IDC_CHECK6))->SetCheck(1);
		GetDlgItem(IDC_EDIT6)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_CHECK7)->EnableWindow(TRUE);
	if (byStatus & 128)
	{
		((CButton *)GetDlgItem(IDC_CHECK7))->SetCheck(1);
		GetDlgItem(IDC_EDIT7)->EnableWindow(TRUE);
	}
	
	SetTimer(1, 100, NULL);
}

BOOL CGeneral_Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetDlgItemText(IDC_GEDTID, "192.168.10.10");

	return TRUE;  
}

void CGeneral_Dlg::OnModulehandlerelease() 
{
	// TODO: Add your control notification handler code here
	KillTimer(1);

	DWORD dwRet;
	dwRet =SYS_Release(mHandle);
	mHandle = NULL;

	GetDlgItem(IDC_EDIT0)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT1)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT3)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT4)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT5)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT6)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT7)->EnableWindow(FALSE);
	SetDlgItemText(IDC_EDIT0, "");
	SetDlgItemText(IDC_EDIT1, "");
	SetDlgItemText(IDC_EDIT2, "");
	SetDlgItemText(IDC_EDIT3, "");
	SetDlgItemText(IDC_EDIT4, "");
	SetDlgItemText(IDC_EDIT5, "");
	SetDlgItemText(IDC_EDIT6, "");
	SetDlgItemText(IDC_EDIT7, "");

	GetDlgItem(IDC_CHECK0)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK1)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK2)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK3)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK4)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK5)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK6)->EnableWindow(FALSE);
	GetDlgItem(IDC_CHECK7)->EnableWindow(FALSE);
	((CButton *)GetDlgItem(IDC_CHECK0))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK2))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK4))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK5))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK6))->SetCheck(0);
	((CButton *)GetDlgItem(IDC_CHECK7))->SetCheck(0);

	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_TIMER)->EnableWindow(FALSE);
	GetDlgItem(IDC_WATCHDOG)->EnableWindow(FALSE);
	SetDlgItemText(IDC_TIMER, "");
	((CButton *)GetDlgItem(IDC_WATCHDOG))->SetCheck(0);

	GetDlgItem(IDC_SETMODULECONFIG)->EnableWindow(FALSE);
	GetDlgItem(IDC_GCBOINPUTRANGE)->EnableWindow(FALSE);
	((CComboBox *)GetDlgItem(IDC_GCBOINPUTRANGE))->SetCurSel(-1);

	SetDlgItemText(IDC_GEDTFIRMWARE, "");
	SetDlgItemText(IDC_GEDTMODULENAME, "");

	GetDlgItem(IDC_MODULEHANDLERELEASE)->EnableWindow(FALSE);
	GetDlgItem(IDC_MODULEHANDLECREATRE)->EnableWindow(TRUE);
}

void CGeneral_Dlg::OnOK() 
{
	if(mHandle) SYS_Release(mHandle);
	CDialog::OnOK();
}

void CGeneral_Dlg::OnCancel() 
{
	if(mHandle) SYS_Release(mHandle);
	CDialog::OnCancel();
}

void CGeneral_Dlg::OnSetwatchdogconfig() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(FALSE);

	BOOL bEnabled = ((CButton*)GetDlgItem(IDC_WATCHDOG))->GetCheck();
	CString cstr;
	GetDlgItemText(IDC_TIMER, cstr);
	double dblWDTimer = atof(cstr);
	SYS_SetWatchDogConfig(mHandle, bEnabled, dblWDTimer);

	GetDlgItem(IDC_SETWATCHDOGCONFIG)->EnableWindow(TRUE);
}

void CGeneral_Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	double dblAI;
	CString str;

	if(((CButton *)GetDlgItem(IDC_CHECK0))->GetCheck())
	{
		AI_GetAI(mHandle, 0, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT0, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK1))->GetCheck())
	{
		AI_GetAI(mHandle, 1, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT1, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK2))->GetCheck())
	{
		AI_GetAI(mHandle, 2, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT2, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK3))->GetCheck())
	{
		AI_GetAI(mHandle, 3, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT3, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK4))->GetCheck())
	{
		AI_GetAI(mHandle, 4, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT4, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK5))->GetCheck())
	{
		AI_GetAI(mHandle, 5, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT5, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK6))->GetCheck())
	{
		AI_GetAI(mHandle, 6, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT6, str);
	}
	if(((CButton *)GetDlgItem(IDC_CHECK7))->GetCheck())
	{
		AI_GetAI(mHandle, 7, &dblAI);
		str.Format("%.3f", dblAI);
		SetDlgItemText(IDC_EDIT7, str);
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CGeneral_Dlg::OnCheck0() 
{
	// TODO: Add your control notification handler code here
	if (((CButton*)GetDlgItem(IDC_CHECK0))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 0, 1);
		GetDlgItem(IDC_EDIT0)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 0, 0);
		GetDlgItem(IDC_EDIT0)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT0, "");
	}
}

void CGeneral_Dlg::OnCheck1() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK1))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 1, 1);
		GetDlgItem(IDC_EDIT1)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 1, 0);
		GetDlgItem(IDC_EDIT1)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT1, "");
	}
}

void CGeneral_Dlg::OnCheck2() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK2))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 2, 1);
		GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 2, 0);
		GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT2, "");
	}
}

void CGeneral_Dlg::OnCheck3() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK3))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 3, 1);
		GetDlgItem(IDC_EDIT3)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 3, 0);
		GetDlgItem(IDC_EDIT3)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT3, "");
	}
}

void CGeneral_Dlg::OnCheck4() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK4))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 4, 1);
		GetDlgItem(IDC_EDIT4)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 4, 0);
		GetDlgItem(IDC_EDIT4)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT4, "");
	}
}

void CGeneral_Dlg::OnCheck5() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK5))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 5, 1);
		GetDlgItem(IDC_EDIT5)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 5, 0);
		GetDlgItem(IDC_EDIT5)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT5, "");
	}
}

void CGeneral_Dlg::OnCheck6() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK6))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 6, 1);
		GetDlgItem(IDC_EDIT6)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 6, 0);
		GetDlgItem(IDC_EDIT6)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT6, "");
	}
}

void CGeneral_Dlg::OnCheck7() 
{
	if (((CButton*)GetDlgItem(IDC_CHECK7))->GetCheck())
	{
		AI_SetChannelStatus(mHandle, 7, 1);
		GetDlgItem(IDC_EDIT7)->EnableWindow(TRUE);
	}
	else
	{
		AI_SetChannelStatus(mHandle, 7, 0);
		GetDlgItem(IDC_EDIT7)->EnableWindow(FALSE);
		SetDlgItemText(IDC_EDIT7, "");
	}
}
