using System;
using System.Runtime.InteropServices;
using System.Text;

namespace BlockIOSDK
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct I5014_ALARM_INFO
    {
        public byte byAlarmStatus;
        public byte byAlarmMode;
        public uint dwAlarmAction;
        public byte byMask;
        public byte byResult;
    }

    public class BlockIO5014r
    {
        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetAI")]
        public static extern uint RTD_GetAI(IntPtr hSession, byte byChId, out double pdblAI);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetChannelStatus")]
        public static extern uint RTD_GetChannelStatus(IntPtr hSession, out byte pbyStatus);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetChannelStatus")]
        public static extern uint RTD_SetChannelStatus(IntPtr hSession, byte byChId, byte byStatus);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetSnmpTrapCount")]
        public static extern uint RTD_SetSnmpTrapCount(IntPtr hSession, byte byCount);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetSnmpTrapCount")]
        public static extern uint RTD_GetSnmpTrapCount(IntPtr hSession, out byte pbyCount);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetSnmpTrapIP")]
        public static extern uint RTD_SetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]string lpszIP);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetSnmpTrapIP")]
        public static extern uint RTD_GetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]StringBuilder lpszIP);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_ResetSnmpTrap")]
        public static extern uint RTD_ResetSnmpTrap(IntPtr hSession);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetAlarmInfo")]
        public static extern uint RTD_GetAlarmInfo(IntPtr hSession, out I5014_ALARM_INFO pAlarmInfo);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetAlarmInfo")]
        public static extern uint RTD_SetAlarmInfo(IntPtr hSession, ref I5014_ALARM_INFO pAlarmInfo);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetAlarmLimits")]
        public static extern uint RTD_SetAlarmLimits(IntPtr hSession, byte byChId, double dblHiVal, double dblLoVal, byte byLimitsMask);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetAlarmLimits")]
        public static extern uint RTD_GetAlarmLimits(IntPtr hSession, byte byChId, out double pdblHiVal, out double pdblLoVal);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_GetInputRange")]
        public static extern uint RTD_GetInputRange(IntPtr hSession, out byte pbyIR);

        [DllImport("BlockIO5014r.dll", EntryPoint = "RTD_SetInputRange")]
        public static extern uint RTD_SetInputRange(IntPtr hSession, byte byIR);
    }
}
