using System;
using System.Runtime.InteropServices;
using System.Text;

namespace BlockIOSDK
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct I5024_PARAM
    {
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
        public byte[] byOutputRanges;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4)]
        public byte[] bySlewRates;
        public byte byMask;
        public byte byResult;
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = 2)]
        public byte[] bydummy;
    }

    public class BlockIO5024r
    {
        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_SetConfig")]
        public static extern uint AO_SetConfig(IntPtr hSession, ref I5024_PARAM pParams);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_GetConfig")]
        public static extern uint AO_GetConfig(IntPtr hSession, out I5024_PARAM pParams);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_GetAO")]
        public static extern uint AO_GetAO(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPArray)]double[] pdblAO);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_SetAO")]
        public static extern uint AO_SetAO(IntPtr hSession, byte byChId, double dblAO);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_GetPowerOnValue")]
        public static extern uint AO_GetPowerOnValue(IntPtr hSession, byte byChId, out UInt16 pwVal);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_SetPowerOnValue")]
        public static extern uint AO_SetPowerOnValue(IntPtr hSession, byte byChId);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_SetSnmpTrapCount")]
        public static extern uint AO_SetSnmpTrapCount(IntPtr hSession, byte byCount);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_GetSnmpTrapCount")]
        public static extern uint AO_GetSnmpTrapCount(IntPtr hSession, out byte pbyCount);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_SetSnmpTrapIP")]
        public static extern uint AO_SetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]string lpszIP);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_GetSnmpTrapIP")]
        public static extern uint AO_GetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]StringBuilder lpszIP);

        [DllImport("BlockIO5024r.dll", EntryPoint = "AO_ResetSnmpTrap")]
        public static extern uint AO_ResetSnmpTrap(IntPtr hSession);
    }
}
