Attribute VB_Name = "BlockIO5068API"
Option Explicit

Declare Function DIO_SetDefault Lib "BlockIO5068r.dll" (ByVal Handle As Long) As Long

Global Const I5068_DI_NUM = 14
Global Const I5068_DO_NUM = 8
Declare Function DIO_GetDIO Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef pbDIs As Byte, ByRef pbDOs As Byte) As Long
Declare Function DIO_SetDOs Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal bDOs As Byte) As Long
Declare Function DIO_SetDO Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byBitPos As Byte, ByVal bDO As Long) As Long

Global Const DI_MODE_DI = 0
Global Const DI_MODE_COUNTER = 1

Declare Function DIO_GetDIMode Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef pwMode As Integer) As Long
Declare Function DIO_SetDIMode Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal wMode As Integer) As Long

Global Const DI_COUNTER_STATUS = 0
Global Const DI_COUNTER_OVER_STATUS = 1
Global Const DI_COUNTER_TRIGGER_MODE = 2
Global Const DI_COUNTER_POWERON_STATUS = 3
Global Const DI_COUNTER_SAFE_STATUS = 4
Global Const DI_COUNTER_CLEAR_VALUE = 5
Global Const DI_INFO_WORD_COUNT = 6

Type I5068_COUNTER_INFO
    wValues(DI_INFO_WORD_COUNT) As Integer
    byMask As Byte       ' for write
    byResult As Byte     ' for write
End Type

Declare Function DIO_GetCounterInfo Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef ptCntInfo As I5068_COUNTER_INFO) As Long
Declare Function DIO_SetCounterInfo Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef ptCntInfo As I5068_COUNTER_INFO) As Long

' byChId: 0 ~ 13, 0xff - all
Declare Function DIO_GetCounterValue Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByRef pdwValue As Long) As Long

Global Const DO_MODE_DO = 0
Global Const DO_MODE_PULSE = 1

Declare Function DIO_GetDOMode Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef pwMode As Integer) As Long
Declare Function DIO_SetDOMode Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal wMode As Integer) As Long


Global Const DO_PULSE_STATUS = 0
Global Const DO_PULSE_POWERON_STATUS = 1
Global Const DO_PULSE_SAFE_STATUS = 2
Global Const DO_POWERON_STATUS = 3
Global Const DO_SAFE_STATUS = 4
Global Const DO_INFO_WORD_COUNT = 5

Type I5068_PULSE_INFO
    wValues(DO_INFO_WORD_COUNT) As Integer
    byMask As Byte       ' for write
    byResult As Byte
End Type

Declare Function DIO_GetPulseInfo Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef ptPulseInfo As I5068_PULSE_INFO) As Long
Declare Function DIO_SetPulseInfo Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef ptPulseInfo As I5068_PULSE_INFO) As Long

' byChId: 0 ~ 7
Declare Function DIO_GetPulseOutputCount Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByRef pdwCount As Long) As Long
Declare Function DIO_SetPulseOutputCount Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByVal dwCount As Long) As Long

' byChId: 0 ~ 7
' pdwFreq: LoWord - low signal width
'          HiWord - high signal width
Declare Function DIO_GetPulseFreq Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByRef pdwFreq As Long) As Long

' nType : 0 - low  1 - high  2 - all
' dwFreq: LoWord   LoWord    LoWord+HiWord
Declare Function DIO_SetPulseFreq Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByVal nType As Long, ByVal dwFreq As Long) As Long

Declare Function DIO_SetSnmpTrapCount Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte) As Long
Declare Function DIO_GetSnmpTrapCount Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByRef ptPulseInfo As Byte) As Long
Declare Function DIO_SetSnmpTrapIP Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByVal lpszIP As String) As Long
Declare Function DIO_GetSnmpTrapIP Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byChId As Byte, ByRef lpszIP As String) As Long
Declare Function DIO_ResetSnmpTrap Lib "BlockIO5068r.dll" (ByVal Handle As Long) As Long
Declare Function DIO_SetSnmpTrapIpHelper Lib "BlockIO5068r.dll" (ByVal hSession As Long, ByVal byChId As Byte, ByVal lpszIP As String, ByVal byChId As Integer) As Long
Declare Function DIO_GetSnmpTrapIpHelper Lib "BlockIO5068r.dll" (ByVal hSession As Long, ByVal byChId As Byte, ByRef lpszIP As String, ByVal byChId As Integer) As Long

Declare Function DIO_SetSafetyDO Lib "BlockIO5068r.dll" (ByVal hSession As Long) As Long
Declare Function DIO_SetPowerOnDO Lib "BlockIO5068r.dll" (ByVal hSession As Long) As Long

Global Const I5068_RULE_COUNT = 8
Global Const I5068_RULE_CONDI_COUNT = 4

Type I5068_LOGIC_RULE_IF
    'if (DI op action) then DO action
    dwSetCntValue As Long  'Set Counter Value
    byDICh As Byte    ' 0 ~ (I5068_DI_NUM-1)
    byOp As Byte    ' 0:On 1:Off 2:Off-On 3:On-Off 4:= 5:> 6:< 7:>= 8:<=
    byFlag As Byte    ' bit 0: disable/enable [bit 1: AI:1 DI:0]
    'BYTE dummy[3];
    wAIValue As Integer
    dummy As Byte
End Type

Global Const LOGIC_ACT_ON = 0
Global Const LOGIC_ACT_OFF = 1
Global Const LOGIC_ACT_CNT_RESET = 2
Global Const LOGIC_ACT_PLS_START = 3
Global Const LOGIC_ACT_PLS_STOP = 4
Global Const LOGIC_ACT_SNMP_TRAP = 5
Global Const LOGIC_ACT_AO_OUT = 6

Global Const LOGIC_RULE_REL_OR = 0
Global Const LOGIC_RULE_REL_AND = 1

Type I5068_LOGIC_RULE_THEN
    byDIOCh As Byte     ' DI or DO Channel
    byAct As Byte       ' 0 ~ 5
                      ' 0:On 1:Off 2:Counter reset 3:Pulse out start 4:Pulse out stop
                      ' 5:Snmp trap [6:AO Output]
    byFlag As Byte       ' bit 0: disable/enable
    wSetAOValue As Integer  ' AO Output Value
    dummy(3) As Byte     'reserve

End Type

Type I5068_LOGIC_RULE
    tIf(I5068_RULE_CONDI_COUNT) As I5068_LOGIC_RULE_IF
    tThen(I5068_RULE_CONDI_COUNT) As I5068_LOGIC_RULE_THEN

    wChkTime As Integer     ' 0 ~ 65535
    wRelIf As Integer       ' 0:OR 1:AND
    byFlag As Byte       ' bit 0: disable/enable [bit 1: 0:Latch 1:Monentary]
    dummy(3) As Byte
End Type


' \/\/:
' byRuleId : 0 ~ I5068_RULE_COUNT-1 or 0xff
Declare Function DIO_GetLogicRules Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byRuleId As Byte, ByRef pRules As I5068_LOGIC_RULE) As Long

' byRuleId : 0 ~ I5068_RULE_COUNT-1 or 0xff
Declare Function DIO_SetLogicRules Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal byRuleId As Byte, ByRef pRules As I5068_LOGIC_RULE) As Long
' /\/\:

' \/\/:  PPIO Service
Global Const I5068_PPIO_FIRMVER = &HF205

Global Const I5068_PPIO_RULE_COUNT = 7

Global Const I5068_PPIO_ENABLED = &H1         ' 0: disabled 1: enabled
Global Const I5068_PPIO_ROLE = &H2            ' 0: client 1: server

Type I5068_PPIO_CONNECT_OPT
    dwSize As Long         ' sizeof(I5068_PPIO_CONNECT_OPT)
    dwFlags As Long        ' See above I5068_PPIO_XXX
    lpszAddr As String     ' Mirror to / Mirror from
End Type

Type I5068_PPIO_VALUE
    dwSize As Long           ' sizeof(I5068_PPIO_VALUE)
    wDInp As Integer
    wDOut As Integer
End Type

Type I5068_PPIO_STATUS
    dwSize As Long          ' sizeof(I5068_PPIO_STATUS)
    wDeviceId As Integer      ' 0x5068 OR 0x5068
    wActive As Integer           ' 1: connect 0: not connect
End Type

Global Const I5068_PPIO_TYPE_CONNECT_OPT = 1
Global Const I5068_PPIO_TYPE_VAULE = 2
Global Const I5068_PPIO_TYPE_STATUS = 3

' nType : See above I5068_PPIO_TYPE_XXX
Declare Function DIO_SetPPIO Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal nType As Integer, ByVal pOpts As Variant) As Long
Declare Function DIO_GetPPIO Lib "BlockIO5068r.dll" (ByVal Handle As Long, ByVal nType As Integer, ByRef pOpts As Variant) As Long

