Option Strict Off
Option Explicit On
Module BlockIO5068API
	
	Declare Function DIO_SetDefault Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer) As Integer
	
    Public Const I5068_DI_NUM As Short = 14
    Public Const I5068_DO_NUM As Short = 8
    Declare Function DIO_GetDIO Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef pbDIs As Byte, ByRef pbDOs As Byte) As Integer
    Declare Function DIO_SetDOs Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal bDOs As Byte) As Integer
    Declare Function DIO_SetDO Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byBitPos As Byte, ByVal bDO As Integer) As Integer

    Public Const DI_MODE_DI As Short = 0
    Public Const DI_MODE_COUNTER As Short = 1

    Declare Function DIO_GetDIMode Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef pwMode As Short) As Integer
    Declare Function DIO_SetDIMode Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal wMode As Short) As Integer

    Public Const DI_COUNTER_STATUS As Short = 0
    Public Const DI_COUNTER_OVER_STATUS As Short = 1
    Public Const DI_COUNTER_TRIGGER_MODE As Short = 2
    Public Const DI_COUNTER_POWERON_STATUS As Short = 3
    Public Const DI_COUNTER_SAFE_STATUS As Short = 4
    Public Const DI_COUNTER_CLEAR_VALUE As Short = 5
    Public Const DI_INFO_WORD_COUNT As Short = 6

    Structure I5068_COUNTER_INFO
        <VBFixedArray(DI_INFO_WORD_COUNT)> Dim wValues() As Short
        Dim byMask As Byte ' for write
        Dim byResult As Byte ' for write

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"'
        Public Sub Initialize()
            ReDim wValues(DI_INFO_WORD_COUNT)
        End Sub
    End Structure

    'UPGRADE_WARNING: Structure I5068_COUNTER_INFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_GetCounterInfo Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef ptCntInfo As I5068_COUNTER_INFO) As Integer
    'UPGRADE_WARNING: Structure I5068_COUNTER_INFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_SetCounterInfo Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef ptCntInfo As I5068_COUNTER_INFO) As Integer

    ' byChId: 0 ~ 13, 0xff - all
    Declare Function DIO_GetCounterValue Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByRef pdwValue As Integer) As Integer

    Public Const DO_MODE_DO As Short = 0
    Public Const DO_MODE_PULSE As Short = 1

    Declare Function DIO_GetDOMode Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef pwMode As Short) As Integer
    Declare Function DIO_SetDOMode Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal wMode As Short) As Integer


    Public Const DO_PULSE_STATUS As Short = 0
    Public Const DO_PULSE_POWERON_STATUS As Short = 1
    Public Const DO_PULSE_SAFE_STATUS As Short = 2
    Public Const DO_POWERON_STATUS As Short = 3
    Public Const DO_SAFE_STATUS As Short = 4
    Public Const DO_INFO_WORD_COUNT As Short = 5

    Structure I5068_PULSE_INFO
        <VBFixedArray(DO_INFO_WORD_COUNT)> Dim wValues() As Short
        Dim byMask As Byte ' for write
        Dim byResult As Byte

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"'
        Public Sub Initialize()
            ReDim wValues(DO_INFO_WORD_COUNT)
        End Sub
    End Structure

    'UPGRADE_WARNING: Structure I5068_PULSE_INFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_GetPulseInfo Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef ptPulseInfo As I5068_PULSE_INFO) As Integer
    'UPGRADE_WARNING: Structure I5068_PULSE_INFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_SetPulseInfo Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef ptPulseInfo As I5068_PULSE_INFO) As Integer

    ' byChId: 0 ~ 7
    Declare Function DIO_GetPulseOutputCount Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByRef pdwCount As Integer) As Integer
    Declare Function DIO_SetPulseOutputCount Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByVal dwCount As Integer) As Integer

    ' byChId: 0 ~ 7
    ' pdwFreq: LoWord - low signal width
    '          HiWord - high signal width
    Declare Function DIO_GetPulseFreq Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByRef pdwFreq As Integer) As Integer

    ' nType : 0 - low  1 - high  2 - all
    ' dwFreq: LoWord   LoWord    LoWord+HiWord
    Declare Function DIO_SetPulseFreq Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByVal nType As Integer, ByVal dwFreq As Integer) As Integer

    Declare Function DIO_SetSnmpTrapCount Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte) As Integer
    Declare Function DIO_GetSnmpTrapCount Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByRef ptPulseInfo As Byte) As Integer
    Declare Function DIO_SetSnmpTrapIP Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByVal lpszIP As String) As Integer
    Declare Function DIO_GetSnmpTrapIP Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byChId As Byte, ByRef lpszIP As String) As Integer
    Declare Function DIO_ResetSnmpTrap Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer) As Integer
    Declare Function DIO_SetSnmpTrapIpHelper Lib "BlockIO5068r.dll" (ByVal hSession As Integer, ByVal byChId As Byte, ByVal lpszIP As String, ByVal byChId As Short) As Integer
    Declare Function DIO_GetSnmpTrapIpHelper Lib "BlockIO5068r.dll" (ByVal hSession As Integer, ByVal byChId As Byte, ByRef lpszIP As String, ByVal byChId As Short) As Integer

    Declare Function DIO_SetSafetyDO Lib "BlockIO5068r.dll" (ByVal hSession As Integer) As Integer
    Declare Function DIO_SetPowerOnDO Lib "BlockIO5068r.dll" (ByVal hSession As Integer) As Integer

    Public Const I5068_RULE_COUNT As Short = 8
    Public Const I5068_RULE_CONDI_COUNT As Short = 4

    Structure I5068_LOGIC_RULE_IF
        'if (DI op action) then DO action
        Dim dwSetCntValue As Integer 'Set Counter Value
        Dim byDICh As Byte ' 0 ~ (I5068_DI_NUM-1)
        Dim byOp As Byte ' 0:On 1:Off 2:Off-On 3:On-Off 4:= 5:> 6:< 7:>= 8:<=
        Dim byFlag As Byte ' bit 0: disable/enable [bit 1: AI:1 DI:0]
        'BYTE dummy[3];
        Dim wAIValue As Short
        Dim dummy As Byte
    End Structure

    Public Const LOGIC_ACT_ON As Short = 0
    Public Const LOGIC_ACT_OFF As Short = 1
    Public Const LOGIC_ACT_CNT_RESET As Short = 2
    Public Const LOGIC_ACT_PLS_START As Short = 3
    Public Const LOGIC_ACT_PLS_STOP As Short = 4
    Public Const LOGIC_ACT_SNMP_TRAP As Short = 5
    Public Const LOGIC_ACT_AO_OUT As Short = 6

    Public Const LOGIC_RULE_REL_OR As Short = 0
    Public Const LOGIC_RULE_REL_AND As Short = 1

    Structure I5068_LOGIC_RULE_THEN
        Dim byDIOCh As Byte ' DI or DO Channel
        Dim byAct As Byte ' 0 ~ 5
        ' 0:On 1:Off 2:Counter reset 3:Pulse out start 4:Pulse out stop
        ' 5:Snmp trap [6:AO Output]
        Dim byFlag As Byte ' bit 0: disable/enable
        Dim wSetAOValue As Short ' AO Output Value
        <VBFixedArray(3)> Dim dummy() As Byte 'reserve

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"'
        Public Sub Initialize()
            ReDim dummy(3)
        End Sub
    End Structure

    Structure I5068_LOGIC_RULE
        <VBFixedArray(I5068_RULE_CONDI_COUNT)> Dim tIf() As I5068_LOGIC_RULE_IF
        'UPGRADE_WARNING: Array tThen may need to have individual elements initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B97B714D-9338-48AC-B03F-345B617E2B02"'
        <VBFixedArray(I5068_RULE_CONDI_COUNT)> Dim tThen() As I5068_LOGIC_RULE_THEN
        Dim wChkTime As Short ' 0 ~ 65535
        Dim wRelIf As Short ' 0:OR 1:AND
        Dim byFlag As Byte ' bit 0: disable/enable [bit 1: 0:Latch 1:Monentary]
        <VBFixedArray(3)> Dim dummy() As Byte

        'UPGRADE_TODO: "Initialize" must be called to initialize instances of this structure. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="B4BFF9E0-8631-45CF-910E-62AB3970F27B"'
        Public Sub Initialize()
            ReDim tIf(I5068_RULE_CONDI_COUNT)
            ReDim tThen(I5068_RULE_CONDI_COUNT)
            ReDim dummy(3)
        End Sub
    End Structure


    ' \/\/:
    ' byRuleId : 0 ~ I5068_RULE_COUNT-1 or 0xff
    'UPGRADE_WARNING: Structure I5068_LOGIC_RULE may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_GetLogicRules Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byRuleId As Byte, ByRef pRules As I5068_LOGIC_RULE) As Integer

    ' byRuleId : 0 ~ I5068_RULE_COUNT-1 or 0xff
    'UPGRADE_WARNING: Structure I5068_LOGIC_RULE may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Declare Function DIO_SetLogicRules Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal byRuleId As Byte, ByRef pRules As I5068_LOGIC_RULE) As Integer
    ' /\/\:

    ' \/\/:  PPIO Service
    Public Const I5068_PPIO_FIRMVER As Short = &HF205S

    Public Const I5068_PPIO_RULE_COUNT As Short = 7

    Public Const I5068_PPIO_ENABLED As Short = &H1S ' 0: disabled 1: enabled
    Public Const I5068_PPIO_ROLE As Short = &H2S ' 0: client 1: server

    Structure I5068_PPIO_CONNECT_OPT
        Dim dwSize As Integer ' sizeof(I5068_PPIO_CONNECT_OPT)
        Dim dwFlags As Integer ' See above I5068_PPIO_XXX
        Dim lpszAddr As String ' Mirror to / Mirror from
    End Structure

    Structure I5068_PPIO_VALUE
        Dim dwSize As Integer ' sizeof(I5068_PPIO_VALUE)
        Dim wDInp As Short
        Dim wDOut As Short
    End Structure

    Structure I5068_PPIO_STATUS
        Dim dwSize As Integer ' sizeof(I5068_PPIO_STATUS)
        Dim wDeviceId As Short ' 0x5068 OR 0x5068
        Dim wActive As Short ' 1: connect 0: not connect
    End Structure

    Public Const I5068_PPIO_TYPE_CONNECT_OPT As Short = 1
    Public Const I5068_PPIO_TYPE_VAULE As Short = 2
    Public Const I5068_PPIO_TYPE_STATUS As Short = 3

    ' nType : See above I5068_PPIO_TYPE_XXX
	Declare Function DIO_SetPPIO Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal nType As Short, ByVal pOpts As Object) As Integer
	Declare Function DIO_GetPPIO Lib "BlockIO5068r.dll" (ByVal HANDLE As Integer, ByVal nType As Short, ByRef pOpts As Object) As Integer
End Module